m=Map("unishare",nil,translate("Configure multiple file sharing protocols in one page (Samba, WebDAV, maybe more in the future?)"))
s=m:section(TypedSection,"global",translate("Global"))
s:tab("general",translate("General Setup"))
s:tab("webdav",translate("WebDAV"))
s.anonymous=true
s.addremove=false
o=s:taboption("general",Flag,"enabled",translate("Enabled"))
o.default=0
o=s:taboption("general",Flag,"anonymous",translate("Allow Anonymous"),
translatef("For logged in users, please manage on the '%s' page",
"<a href=\""..luci.dispatcher.build_url("admin","nas","unishare","users").."\" >"..translate("Users").."</a>"))
o.default=0
o=s:taboption("webdav",Value,"webdav_port",translate("WebDAV Port"))
o.datatype="port"
s=m:section(TypedSection,"share",translate("Shares"),translate("(The user marked in <b>Bold</b> has write access)"))
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
s.extedit=luci.dispatcher.build_url("admin","nas","unishare","share","%s")
function s.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s.extedit%e)
end
path=s:option(Value,"path",translate("Path"))
path.datatype="string"
path.rmempty=false
path.validate=function(a,e,t)
if e then
if e=="/"or string.match(e,"^/.+[^/]$")then
if e=="/"and(nil==name:formvalue(t)or""==name:formvalue(t))then
return nil,translate("Name cannot be empty when Path is /")
end
return e
else
return nil,translate("Path must starts with '/' and not ends with '/'")
end
end
return AbstractValue.validate(a,e,t)
end
name=s:option(Value,"name",translate("Name"))
name.datatype="string"
name.rmempty=true
name.validate=function(t,e,a)
if e and string.match(e,"[`&|;<>/\\*?$#]")then
return nil,translatef("Name must not contains '%s'","`&|;<>/\\*?$#")
end
return AbstractValue.validate(t,e,a)
end
local function t(e,t)
if e==nil then
return"&#8212;"
end
if type(e)=="table"then
return table.concat(e,t)
else
return e
end
end
o=s:option(DummyValue,"users",translate("Users"))
o.rawhtml=true
function o.cfgvalue(e,a)
return"<b>"..t(e.map:get(a,"rw")," ").."</b><br><i>"..t(e.map:get(a,"ro")," ").."</i>"
end
o=s:option(StaticList,"proto",translate("Protocol"))
o:value("samba","Samba")
o:value("webdav","WebDAV")
return m
